Index: source/renderer/PatchRData.cpp
===================================================================
--- source/renderer/PatchRData.cpp	(revision 11919)
+++ source/renderer/PatchRData.cpp	(working copy)
@@ -367,6 +367,7 @@
 
 	terrain->CalcPosition(gx, gz, dst.m_Position);
 	terrain->CalcNormal(gx, gz, normal);
+	dst.m_Normal = normal;
 	dst.m_DiffuseColor = cpuLighting ? lightEnv.EvaluateTerrainDiffuseScaled(normal) : lightEnv.EvaluateTerrainDiffuseFactor(normal);
 	dst.m_AlphaUVs[0] = vtx[0].m_AlphaUVs[0];
 	dst.m_AlphaUVs[1] = vtx[0].m_AlphaUVs[1];
@@ -374,6 +375,7 @@
 
 	terrain->CalcPosition(gx + 1, gz, dst.m_Position);
 	terrain->CalcNormal(gx + 1, gz, normal);
+	dst.m_Normal = normal;
 	dst.m_DiffuseColor = cpuLighting ? lightEnv.EvaluateTerrainDiffuseScaled(normal) : lightEnv.EvaluateTerrainDiffuseFactor(normal);
 	dst.m_AlphaUVs[0] = vtx[1].m_AlphaUVs[0];
 	dst.m_AlphaUVs[1] = vtx[1].m_AlphaUVs[1];
@@ -381,6 +383,7 @@
 
 	terrain->CalcPosition(gx + 1, gz + 1, dst.m_Position);
 	terrain->CalcNormal(gx + 1, gz + 1, normal);
+	dst.m_Normal = normal;
 	dst.m_DiffuseColor = cpuLighting ? lightEnv.EvaluateTerrainDiffuseScaled(normal) : lightEnv.EvaluateTerrainDiffuseFactor(normal);
 	dst.m_AlphaUVs[0] = vtx[2].m_AlphaUVs[0];
 	dst.m_AlphaUVs[1] = vtx[2].m_AlphaUVs[1];
@@ -388,6 +391,7 @@
 
 	terrain->CalcPosition(gx, gz + 1, dst.m_Position);
 	terrain->CalcNormal(gx, gz + 1, normal);
+	dst.m_Normal = normal;
 	dst.m_DiffuseColor = cpuLighting ? lightEnv.EvaluateTerrainDiffuseScaled(normal) : lightEnv.EvaluateTerrainDiffuseFactor(normal);
 	dst.m_AlphaUVs[0] = vtx[3].m_AlphaUVs[0];
 	dst.m_AlphaUVs[1] = vtx[3].m_AlphaUVs[1];
@@ -546,6 +550,8 @@
 			// for all vertices, it need not be stored in the vertex structure)
 			CVector3D normal;
 			terrain->CalcNormal(ix,iz,normal);
+			
+			vertices[v].m_Normal = normal;
 
 			vertices[v].m_DiffuseColor = cpuLighting ? lightEnv.EvaluateTerrainDiffuseScaled(normal) : lightEnv.EvaluateTerrainDiffuseFactor(normal);
 		}
@@ -747,6 +753,15 @@
 		if (itt->first)
 		{
 			shader->BindTexture("baseTex", itt->first->GetTexture());
+			
+			shader->Uniform("hasNormalMap", itt->first->GetNormal() ? CVector3D(1,0,0) : CVector3D(0,0,0));
+			shader->Uniform("hasSpecularMap", itt->first->GetSpecular() ? CVector3D(1,0,0) : CVector3D(0,0,0));
+			
+			if (itt->first->GetNormal())	
+				shader->BindTexture("normTex", itt->first->GetNormal());
+			
+			if (itt->first->GetSpecular())	
+				shader->BindTexture("specTex", itt->first->GetSpecular());
 
 #if !CONFIG2_GLES
 			if (isDummyShader)
@@ -774,6 +789,7 @@
 			SBaseVertex *base = (SBaseVertex *)itv->first->Bind();
 			shader->VertexPointer(3, GL_FLOAT, stride, &base->m_Position[0]);
 			shader->ColorPointer(4, GL_UNSIGNED_BYTE, stride, &base->m_DiffuseColor);
+			shader->NormalPointer(GL_FLOAT, stride, &base->m_Normal[0]);				
 			shader->TexCoordPointer(GL_TEXTURE0, 3, GL_FLOAT, stride, &base->m_Position[0]);
 
 			shader->AssertPointersBound();
@@ -932,6 +948,16 @@
 		if (itt->m_Texture)
 		{
 			shader->BindTexture("baseTex", itt->m_Texture->GetTexture());
+			
+			shader->Uniform("hasNormalMap", itt->m_Texture->GetNormal() ? CVector3D(1,0,0) : CVector3D(0,0,0));
+			shader->Uniform("hasSpecularMap", itt->m_Texture->GetSpecular() ? CVector3D(1,0,0) : CVector3D(0,0,0));
+			
+			if (itt->m_Texture->GetNormal())
+				shader->BindTexture("normTex", itt->m_Texture->GetNormal());
+			
+			if (itt->m_Texture->GetSpecular())
+				shader->BindTexture("specTex", itt->m_Texture->GetSpecular());
+			
 
 #if !CONFIG2_GLES
 			if (isDummyShader)
@@ -965,6 +991,7 @@
 
 				shader->VertexPointer(3, GL_FLOAT, stride, &base->m_Position[0]);
 				shader->ColorPointer(4, GL_UNSIGNED_BYTE, stride, &base->m_DiffuseColor);
+				shader->NormalPointer(GL_FLOAT, stride, &base->m_Normal[0]);
 				shader->TexCoordPointer(GL_TEXTURE0, 3, GL_FLOAT, stride, &base->m_Position[0]);
 				shader->TexCoordPointer(GL_TEXTURE1, 2, GL_FLOAT, stride, &base->m_AlphaUVs[0]);
 			}
Index: source/renderer/RenderModifiers.cpp
===================================================================
--- source/renderer/RenderModifiers.cpp	(revision 11919)
+++ source/renderer/RenderModifiers.cpp	(working copy)
@@ -104,6 +104,8 @@
 	m_BindingShadingColor = shader->GetUniformBinding("shadingColor");
 	m_BindingPlayerColor = shader->GetUniformBinding("playerColor");
 	m_BindingBaseTex = shader->GetTextureBinding("baseTex");
+	m_BindingNormTex = shader->GetTextureBinding("normTex");
+	m_BindingSpecTex = shader->GetTextureBinding("specTex");
 }
 
 void ShaderRenderModifier::PrepareTexture(const CShaderProgramPtr& shader, CTexture& texture)
@@ -112,6 +114,18 @@
 		shader->BindTexture(m_BindingBaseTex, texture.GetHandle());
 }
 
+void ShaderRenderModifier::PrepareNormal(const CShaderProgramPtr& shader, CTexture& normal)
+{
+	if (m_BindingNormTex.Active())
+		shader->BindTexture(m_BindingNormTex, normal.GetHandle());
+}
+
+void ShaderRenderModifier::PrepareSpecular(const CShaderProgramPtr& shader, CTexture& specular)
+{
+	if (m_BindingSpecTex.Active())
+		shader->BindTexture(m_BindingSpecTex, specular.GetHandle());
+}
+
 void ShaderRenderModifier::PrepareModel(const CShaderProgramPtr& shader, CModel* model)
 {
 	if (m_BindingInstancingTransform.Active())
Index: source/renderer/MikktspaceWrap.cpp
===================================================================
--- source/renderer/MikktspaceWrap.cpp	(revision 0)
+++ source/renderer/MikktspaceWrap.cpp	(revision 0)
@@ -0,0 +1,118 @@
+
+#include "precompiled.h"
+
+#include <boost/bind.hpp>
+
+#include "graphics/Color.h"
+#include "graphics/LightEnv.h"
+#include "graphics/Model.h"
+#include "graphics/ModelDef.h"
+#include "graphics/ShaderManager.h"
+#include "graphics/TextureManager.h"
+#include <graphics/mikktspace.h>
+
+#include <renderer/MikktspaceWrap.h>
+
+
+
+MikkTSpace::MikkTSpace(const CModelDefPtr& m, std::vector<float>& v) : model(m), newVertices(v)
+{	
+	interface.m_getNumFaces = getNumFaces;
+	interface.m_getNumVerticesOfFace = getNumVerticesOfFace;
+	interface.m_getPosition = getPosition;
+	interface.m_getNormal = getNormal;
+	interface.m_getTexCoord = getTexCoord;
+	interface.m_setTSpaceBasic = NULL;
+	interface.m_setTSpace = setTSpace;
+
+	context.m_pInterface = &interface;
+	context.m_pUserData = (void*)this;
+}
+
+void MikkTSpace::generate()
+{
+	genTangSpaceDefault(&context);
+}
+
+
+int MikkTSpace::getNumFaces(const SMikkTSpaceContext *pContext)
+{
+	return ((MikkTSpace*)pContext->m_pUserData)->model->GetNumFaces();
+}
+
+
+int MikkTSpace::getNumVerticesOfFace(const SMikkTSpaceContext *pContext, const int iFace)
+{
+	return 3;
+}
+
+
+void MikkTSpace::getPosition(const SMikkTSpaceContext *pContext, 
+		float fvPosOut[], const int iFace, const int iVert)
+{
+	SModelFace &face = ((MikkTSpace*)pContext->m_pUserData)->model->GetFaces()[iFace];
+	long i = face.m_Verts[iVert];
+	const CVector3D &p = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_Coords;
+
+	fvPosOut[0] = p.X;
+	fvPosOut[1] = p.Y;
+	fvPosOut[2] = p.Z;
+}
+
+
+void MikkTSpace::getNormal(const SMikkTSpaceContext *pContext, 
+		float fvNormOut[], const int iFace, const int iVert)
+{
+	SModelFace &face = ((MikkTSpace*)pContext->m_pUserData)->model->GetFaces()[iFace];
+	long i = face.m_Verts[iVert];
+	const CVector3D &n = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_Norm;
+
+	fvNormOut[0] = n.X;
+	fvNormOut[1] = n.Y;
+	fvNormOut[2] = n.Z;
+}
+
+
+void MikkTSpace::getTexCoord(const SMikkTSpaceContext *pContext, 
+		float fvTexcOut[], const int iFace, const int iVert)
+{
+	SModelFace &face = ((MikkTSpace*)pContext->m_pUserData)->model->GetFaces()[iFace];
+	long i = face.m_Verts[iVert];
+	SModelVertex &v = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i];
+
+	fvTexcOut[0] = v.m_U;
+	fvTexcOut[1] = 1.0-v.m_V;		
+}
+
+
+void MikkTSpace::setTSpace(const SMikkTSpaceContext * pContext, const float fvTangent[], 
+		const float fvBiTangent[], const float fMagS, const float fMagT, 
+		const tbool bIsOrientationPreserving, const int iFace, const int iVert)
+{
+	SModelFace &face = ((MikkTSpace*)pContext->m_pUserData)->model->GetFaces()[iFace];
+	long i = face.m_Verts[iVert];
+	
+	const CVector3D &p = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_Coords;
+	const CVector3D &n = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_Norm;
+	const float u = ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_U;
+	const float v = 1.0 - ((MikkTSpace*)pContext->m_pUserData)->model->GetVertices()[i].m_V;
+	
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(p.X);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(p.Y);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(p.Z);
+	
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(n.X);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(n.Y);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(n.Z);
+	
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(u);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(v);
+	
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(fvTangent[0]);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(fvTangent[1]);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(fvTangent[2]);
+	((MikkTSpace*)pContext->m_pUserData)->newVertices.push_back(bIsOrientationPreserving > 0.5 ? 1.0f : (-1.0f));
+}
+
+
+
Index: source/renderer/ModelRenderer.h
===================================================================
--- source/renderer/ModelRenderer.h	(revision 11919)
+++ source/renderer/ModelRenderer.h	(working copy)
@@ -253,6 +253,9 @@
 	static void BuildIndices(
 			const CModelDefPtr& mdef,
 			const VertexArrayIterator<u16>& Indices);
+
+
+	static void GenTangents(const CModelDefPtr& mdef, std::vector<float>& newVertices);
 };
 
 
Index: binaries/data/mods/public/art/textures/terrain/types/snow/snow grass 2.xml
===================================================================
--- binaries/data/mods/public/art/textures/terrain/types/snow/snow grass 2.xml	(revision 0)
+++ binaries/data/mods/public/art/textures/terrain/types/snow/snow grass 2.xml	(revision 0)
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
+
+<!DOCTYPE Terrains SYSTEM "/art/textures/terrain/types/terrains.dtd">
+
+<Terrains>
+	<Terrain normalmap="art/textures/terrain/types/snow/snow grass 2_norm.png" specularmap="art/textures/terrain/types/snow/snow grass 2_spec.png"/>
+</Terrains>
Index: binaries/data/mods/public/shaders/glsl/terrain_common.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/terrain_common.fs	(revision 11919)
+++ binaries/data/mods/public/shaders/glsl/terrain_common.fs	(working copy)
@@ -1,6 +1,8 @@
 #version 120
 
 uniform sampler2D baseTex;
+uniform sampler2D normTex;
+uniform sampler2D specTex;
 uniform sampler2D blendTex;
 uniform sampler2D losTex;
 
@@ -17,13 +19,22 @@
 
 uniform vec3 shadingColor;
 uniform vec3 ambient;
+uniform vec3 sunDir;
 
+uniform vec3 sunColor;
+
+uniform vec3 hasNormalMap;
+uniform vec3 hasSpecularMap;
+
 varying vec3 v_lighting;
 varying vec2 v_tex;
 varying vec4 v_shadow;
 varying vec2 v_los;
 varying vec2 v_blend;
+varying vec3 v_normal;
 
+varying vec3 v_half;
+
 #if USE_SPECULAR
   uniform float specularPower;
   uniform vec3 specularColor;
@@ -40,12 +51,12 @@
         vec4 size = vec4(offset + 1.0, 2.0 - offset);
         vec4 weight = (vec4(2.0 - 1.0 / size.xy, 1.0 / size.zw - 1.0) + (v_shadow.xy - offset).xyxy) * shadowScale.zwzw;
         return (1.0/9.0)*dot(size.zxzx*size.wwyy,
-          vec4(shadow2D(shadowTex, vec3(weight.zw, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.xw, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.zy, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.xy, v_shadow.z)).a));
+          vec4(shadow2D(shadowTex, vec3(weight.zw, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.xw, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.zy, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.xy, v_shadow.z)).r));
       #else
-        return shadow2D(shadowTex, v_shadow.xyz).a;
+        return shadow2D(shadowTex, v_shadow.xyz).r;
       #endif
     #else
       if (v_shadow.z >= 1.0)
@@ -83,8 +94,40 @@
     vec3 specular = vec3(0.0);
   #endif
 
-  vec3 color = (texdiffuse * sundiffuse + specular) * get_shadow() + texdiffuse * ambient;
+	vec3 bump = sundiffuse;
+	if (hasNormalMap.x > 0.5)
+	{
+		vec3 t = vec3(1, 0, 0);
+		t = normalize(t - v_normal * dot(v_normal, t));
+		vec3 b = cross(v_normal, t);
+		//vec3 b = vec3(0, 0, 1);
+		//b = normalize(b - v_normal * dot(v_normal, b));
 
+
+		mat3 tbn = transpose(mat3(t, b, v_normal));
+		vec3 ntex = texture2D(normTex, v_tex).rgb * 2.0 - 1.0;
+		vec3 vNout = normalize(ntex * tbn);
+
+
+		bump = vec3(max (dot (-sunDir, vNout), 0.0)) * sunColor;
+
+		vec4 specColour = vec4(1.0);
+
+		if (hasSpecularMap.x > 0.5)
+		{
+			specColour = texture2D(specTex, v_tex);
+			specular = specColour.xyz * sunColor * pow(max(0.0, dot(normalize(vNout), v_half)), 12);
+		}
+	}
+
+
+	//vec3 specular;
+
+	
+
+
+  vec3 color = (texdiffuse + specular) * bump * get_shadow() + texdiffuse * ambient;
+
   float los = texture2D(losTex, v_los).a;
   color *= los;
 
Index: binaries/data/mods/public/shaders/glsl/hdr.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/hdr.fs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/hdr.fs	(revision 0)
@@ -0,0 +1,64 @@
+#version 110
+
+varying vec2 v_tex;
+
+uniform sampler2D bgl_RenderedTexture;
+uniform sampler2D bgl_DepthTexture;
+uniform sampler2D bgl_LuminanceTexture;
+uniform float bgl_RenderedTextureWidth;
+uniform float bgl_RenderedTextureHeight;
+
+#define PI    3.14159265
+
+float width = bgl_RenderedTextureWidth; //texture width
+float height = bgl_RenderedTextureHeight; //texture height
+
+vec2 texCoord = v_tex;
+vec2 texcoord = v_tex;
+
+
+
+///float avgL = 0.38;
+//float HDRamount = 0.3;
+///float HDRamount = 0.1;
+
+//float avgL = 0.4;
+//float HDRamount = 0.1;
+
+//float avgL = 0.65;
+//float HDRamount = 0.1;
+
+float avgL = 0.7;
+float HDRamount = 0.1;
+
+void main(void)
+{
+	//gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+	//return;
+	
+
+	//avgL = int(texcoord.x * 10) / 10.0;
+	//HDRamount = int(texcoord.y * 10) / 10.0;
+
+	
+
+
+
+	float contrast = avgL;
+	float brightness = avgL * HDRamount;
+	
+	vec4 value =  texture2D(bgl_RenderedTexture, texcoord);
+
+	//value *= 0.5;
+	
+	gl_FragColor = (value/contrast)-brightness;
+
+	///float grey = (gl_FragColor.r + gl_FragColor.g + gl_FragColor.b) / 3.0;
+
+	///gl_FragColor = vec4(mix(gl_FragColor.rgb, vec3(grey), 0.2), 1.0);
+
+	//if (texcoord.x > 0.75) gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+
+}
+
+
Index: binaries/data/mods/public/shaders/glsl/model_common_norm.vs
===================================================================
--- binaries/data/mods/public/shaders/glsl/model_common_norm.vs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/model_common_norm.vs	(revision 0)
@@ -0,0 +1,110 @@
+#if USE_GPU_SKINNING
+// Skinning requires GLSL 1.30 for ivec4 vertex attributes
+#version 130
+#else
+#version 120
+#endif
+
+uniform mat4 transform;
+uniform vec3 cameraPos;
+uniform vec3 sunDir;
+uniform vec3 sunColor;
+uniform vec2 losTransform;
+uniform mat4 shadowTransform;
+uniform mat4 instancingTransform;
+
+//varying vec3 v_lighting;
+varying vec2 v_tex;
+varying vec4 v_shadow;
+varying vec2 v_los;
+
+//#if USE_SPECULAR
+  varying vec3 v_half;
+//#endif
+
+attribute vec3 a_vertex;
+attribute vec3 a_normal;
+attribute vec2 a_uv0;
+
+attribute vec4 a_tangent;
+
+
+
+#if USE_GPU_SKINNING
+  const int MAX_INFLUENCES = 4;
+  const int MAX_BONES = 64;
+  uniform mat4 skinBlendMatrices[MAX_BONES];
+  attribute ivec4 a_skinJoints;
+  attribute vec4 a_skinWeights;
+#endif
+
+varying vec4 debugx;
+
+
+
+
+//varying vec3 lightVec;
+varying vec3 eyeVec;
+
+varying vec3 v_normal;
+varying vec4 v_tangent;
+varying vec3 v_bitangent;
+
+
+//varying float sign;
+
+
+void main()
+{
+  #if USE_GPU_SKINNING
+    vec3 p = vec3(0.0);
+    vec3 n = vec3(0.0);
+    for (int i = 0; i < MAX_INFLUENCES; ++i) {
+      int joint = a_skinJoints[i];
+      if (joint != 0xff) {
+        mat4 m = skinBlendMatrices[joint];
+        p += vec3(m * vec4(a_vertex, 1.0)) * a_skinWeights[i];
+        n += vec3(m * vec4(a_normal, 0.0)) * a_skinWeights[i];
+      }
+    }
+    vec4 position = instancingTransform * vec4(p, 1.0);
+    vec3 normal = mat3(instancingTransform) * normalize(n);
+  #else
+  #if USE_INSTANCING
+    vec4 position = instancingTransform * vec4(a_vertex, 1.0);
+    vec3 normal = mat3(instancingTransform) * a_normal;
+    vec4 tangent = vec4(mat3(instancingTransform) * a_tangent.xyz, a_tangent.w);
+  #else
+    vec4 position = vec4(a_vertex, 1.0);
+    vec3 normal = a_normal;
+    vec4 tangent = a_tangent;    
+  #endif
+  #endif
+
+  gl_Position = transform * position;
+
+
+
+
+	eyeVec = cameraPos.xyz - position.xyz;
+	//lightVec = -sunDir;
+
+
+	
+ 
+	vec3 sunVec = -sunDir;
+    
+	v_half = normalize(sunVec + eyeVec);
+
+	
+	v_normal = normal;
+	v_tangent = tangent;//.xyz;
+	//sign = tangent.w;
+	v_bitangent = cross(v_normal, v_tangent);
+	
+
+  //v_lighting = max(0.0, dot(normal, -sunDir)) * sunColor;
+  v_tex = a_uv0;
+  v_shadow = shadowTransform * position;
+  v_los = position.xz * losTransform.x + losTransform.y;
+}
Index: binaries/data/mods/public/shaders/glsl/ssao.vs
===================================================================
--- binaries/data/mods/public/shaders/glsl/ssao.vs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/ssao.vs	(revision 0)
@@ -0,0 +1,37 @@
+#version 110
+
+uniform mat4 transform;
+
+varying vec2 v_tex;
+
+attribute vec3 a_vertex;
+attribute vec2 a_uv0;
+
+void main()
+{
+  //gl_Position = transform * vec4(a_vertex, 1.0);
+  gl_Position = gl_Vertex;  
+
+  v_tex = vec2(gl_MultiTexCoord0);
+}
+
+
+/*#version 110
+
+void main(void)
+{
+  gl_Position = gl_Vertex;  
+}
+
+//uniform mat4 transform;
+
+//attribute vec3 a_vertex;
+
+varying float  uv;
+
+
+void main()
+{
+  gl_Position = gl_Vertex;  
+}
+*/
\ No newline at end of file
Index: binaries/data/mods/public/shaders/glsl/terrain_common.vs
===================================================================
--- binaries/data/mods/public/shaders/glsl/terrain_common.vs	(revision 11919)
+++ binaries/data/mods/public/shaders/glsl/terrain_common.vs	(working copy)
@@ -17,13 +17,17 @@
 varying vec4 v_shadow;
 varying vec2 v_los;
 varying vec2 v_blend;
+varying vec3 v_normal;
 
+varying vec3 v_half;
+
 #if USE_SPECULAR
   varying vec3 v_normal;
   varying vec3 v_half;
 #endif
 
 attribute vec3 a_vertex;
+attribute vec3 a_normal;
 attribute vec3 a_color;
 attribute vec2 a_uv0;
 attribute vec2 a_uv1;
@@ -35,6 +39,10 @@
   gl_Position = transform * position;
 
   v_lighting = a_color * sunColor;
+
+  //v_lighting = dot(-sunDir, a_normal) * sunColor;
+
+  //v_lighting = sunColor;
   
   #if DECAL
     v_tex = a_uv0;
@@ -72,5 +80,14 @@
     v_normal = normal;
   #endif
 
+	vec3 eyeVec = cameraPos.xyz - position.xyz;
+	
+ 
+	vec3 sunVec = -sunDir;
+    
+	v_half = normalize(sunVec + eyeVec);
+
+  v_normal = a_normal;
+
   v_los = a_vertex.xz * losTransform.x + losTransform.yy;
 }
Index: binaries/data/mods/public/shaders/glsl/hdr.vs
===================================================================
--- binaries/data/mods/public/shaders/glsl/hdr.vs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/hdr.vs	(revision 0)
@@ -0,0 +1,37 @@
+#version 110
+
+uniform mat4 transform;
+
+varying vec2 v_tex;
+
+attribute vec3 a_vertex;
+attribute vec2 a_uv0;
+
+void main()
+{
+  //gl_Position = transform * vec4(a_vertex, 1.0);
+  gl_Position = gl_Vertex;  
+
+  v_tex = vec2(gl_MultiTexCoord0);
+}
+
+
+/*#version 110
+
+void main(void)
+{
+  gl_Position = gl_Vertex;  
+}
+
+//uniform mat4 transform;
+
+//attribute vec3 a_vertex;
+
+varying float  uv;
+
+
+void main()
+{
+  gl_Position = gl_Vertex;  
+}
+*/
\ No newline at end of file
Index: binaries/data/mods/public/shaders/glsl/bloom.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/bloom.fs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/bloom.fs	(revision 0)
@@ -0,0 +1,88 @@
+#version 110
+
+varying vec2 v_tex;
+
+uniform sampler2D bgl_RenderedTexture;
+uniform sampler2D bgl_DepthTexture;
+uniform sampler2D bgl_LuminanceTexture;
+uniform float bgl_RenderedTextureWidth;
+uniform float bgl_RenderedTextureHeight;
+
+#define PI    3.14159265
+
+float width = bgl_RenderedTextureWidth; //texture width
+float height = bgl_RenderedTextureHeight; //texture height
+
+vec2 texCoord = v_tex;
+vec2 texcoord = v_tex;
+
+
+//float BRIGHT_PASS_THRESHOLD = 0.3;
+//float BRIGHT_PASS_OFFSET = 0.5;
+
+float BRIGHT_PASS_THRESHOLD = 0.6;
+float BRIGHT_PASS_OFFSET = 0.6;
+
+#define blurclamp 0.0015
+#define bias 0.01
+
+#define KERNEL_SIZE  3.0
+
+
+
+vec4 bright(vec2 coo)
+{
+	//BRIGHT_PASS_THRESHOLD = int(texcoord.x * 10) / 10.0;
+	//BRIGHT_PASS_OFFSET = int(texcoord.y * 10) / 10.0;
+	
+	vec4 color = texture2D(bgl_RenderedTexture, coo);
+	
+	color = max(color - BRIGHT_PASS_THRESHOLD, 0.0);
+	
+	return color / (color + BRIGHT_PASS_OFFSET);	
+}
+
+
+void main(void)
+{	
+	//gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+	//return;
+
+
+	vec2 blur = vec2(clamp( bias, -blurclamp, blurclamp ));
+	
+	vec4 col = vec4( 0, 0, 0, 0 );
+	for ( float x = -KERNEL_SIZE + 1.0; x < KERNEL_SIZE; x += 1.0 )
+	{
+	for ( float y = -KERNEL_SIZE + 1.0; y < KERNEL_SIZE; y += 1.0 )
+	{
+		 col += bright( texcoord + vec2( blur.x * x, blur.y * y ) );
+	}
+	}
+	col /= ((KERNEL_SIZE+KERNEL_SIZE)-1.0)*((KERNEL_SIZE+KERNEL_SIZE)-1.0);
+	//gl_FragColor = col + texture2D(bgl_RenderedTexture, texcoord);
+
+	//col *= 0.9;
+	gl_FragColor = 1.0 - (1.0 - col) * (1.0 - texture2D(bgl_RenderedTexture, texcoord));
+
+
+	/*vec3 color = texture2D(bgl_RenderedTexture,texCoord).rgb;
+	vec3 luminance = texture2D(bgl_LuminanceTexture,texCoord).rgb;
+	vec3 white = vec3(1.0,1.0,1.0);
+	vec3 black = vec3(0.0,0.0,0.0);
+	//vec3 treshold = vec3(0.2,0.2,0.2);
+
+	vec3 treshold = vec3(0.3);
+	
+	luminance = clamp(max(black,luminance-treshold)+max(black,luminance-treshold)+max(black,luminance-treshold),0.0,1.0);
+	
+	if (texcoord.x > 0.5)
+	gl_FragColor = vec4(mix(gl_FragColor.rgb,color,1.0-luminance),1.0);*/
+	
+
+	//gl_FragColor = mix(gl_FragColor, texture2D(bgl_RenderedTexture, texcoord), 0.5);
+
+	//if (texcoord.x > 0.5) gl_FragColor = texture2D(bgl_RenderedTexture, texcoord);
+
+}
+
Index: binaries/data/mods/public/shaders/glsl/model_common.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/model_common.fs	(revision 11919)
+++ binaries/data/mods/public/shaders/glsl/model_common.fs	(working copy)
@@ -47,12 +47,12 @@
         vec4 size = vec4(offset + 1.0, 2.0 - offset);
         vec4 weight = (vec4(2.0 - 1.0 / size.xy, 1.0 / size.zw - 1.0) + (v_shadow.xy - offset).xyxy) * shadowScale.zwzw;
         return (1.0/9.0)*dot(size.zxzx*size.wwyy,
-          vec4(shadow2D(shadowTex, vec3(weight.zw, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.xw, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.zy, v_shadow.z)).a,
-               shadow2D(shadowTex, vec3(weight.xy, v_shadow.z)).a));
+          vec4(shadow2D(shadowTex, vec3(weight.zw, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.xw, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.zy, v_shadow.z)).r,
+               shadow2D(shadowTex, vec3(weight.xy, v_shadow.z)).r));
       #else
-        return shadow2D(shadowTex, v_shadow.xyz).a;
+        return shadow2D(shadowTex, v_shadow.xyz).r;
       #endif
     #else
       if (v_shadow.z >= 1.0)
Index: binaries/data/mods/public/shaders/glsl/bloom.vs
===================================================================
--- binaries/data/mods/public/shaders/glsl/bloom.vs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/bloom.vs	(revision 0)
@@ -0,0 +1,37 @@
+#version 110
+
+uniform mat4 transform;
+
+varying vec2 v_tex;
+
+attribute vec3 a_vertex;
+attribute vec2 a_uv0;
+
+void main()
+{
+  //gl_Position = transform * vec4(a_vertex, 1.0);
+  gl_Position = gl_Vertex;  
+
+  v_tex = vec2(gl_MultiTexCoord0);
+}
+
+
+/*#version 110
+
+void main(void)
+{
+  gl_Position = gl_Vertex;  
+}
+
+//uniform mat4 transform;
+
+//attribute vec3 a_vertex;
+
+varying float  uv;
+
+
+void main()
+{
+  gl_Position = gl_Vertex;  
+}
+*/
\ No newline at end of file
Index: binaries/data/mods/public/shaders/glsl/model_common_norm.fs
===================================================================
--- binaries/data/mods/public/shaders/glsl/model_common_norm.fs	(revision 0)
+++ binaries/data/mods/public/shaders/glsl/model_common_norm.fs	(revision 0)
@@ -0,0 +1,212 @@
+#version 120
+
+uniform sampler2D baseTex;
+uniform sampler2D normTex;
+uniform sampler2D losTex;
+uniform sampler2D specTex;
+
+#if USE_SHADOW
+  #if USE_SHADOW_SAMPLER
+    uniform sampler2DShadow shadowTex;
+  #else
+    uniform sampler2D shadowTex;
+  #endif
+#endif
+
+#if USE_OBJECTCOLOR
+  uniform vec3 objectColor;
+#else
+#if USE_PLAYERCOLOR
+  uniform vec3 playerColor;
+#endif
+#endif
+
+uniform vec3 ambient;
+uniform vec4 shadowOffsets1;
+uniform vec4 shadowOffsets2;
+
+//uniform mat4 normalMatrix;
+
+//varying vec3 v_lighting;
+varying vec2 v_tex;
+varying vec4 v_shadow;
+varying vec2 v_los;
+
+uniform vec3 sunDir;
+uniform vec3 sunColor;
+
+/*#if USE_SPECULAR
+  uniform float specularPower;
+  uniform vec3 specularColor;
+  varying vec3 v_normal;
+#endif*/
+
+varying vec3 v_half;
+
+//varying vec3 lightVec;	
+varying vec3 eyeVec;
+varying vec3 v_normal;
+varying vec4 v_tangent;
+varying vec3 v_bitangent;
+
+
+//varying float sign;
+
+
+float get_shadow()
+{
+  #if USE_SHADOW && !DISABLE_RECEIVE_SHADOWS
+    #if USE_SHADOW_SAMPLER
+      #if USE_SHADOW_PCF
+        return 0.25 * (
+          shadow2D(shadowTex, vec3(v_shadow.xy + shadowOffsets1.xy, v_shadow.z)).r +
+          shadow2D(shadowTex, vec3(v_shadow.xy + shadowOffsets1.zw, v_shadow.z)).r +
+          shadow2D(shadowTex, vec3(v_shadow.xy + shadowOffsets2.xy, v_shadow.z)).r +
+          shadow2D(shadowTex, vec3(v_shadow.xy + shadowOffsets2.zw, v_shadow.z)).r
+        );
+      #else
+        return shadow2D(shadowTex, v_shadow.xyz).r;
+      #endif
+    #else
+      if (v_shadow.z >= 1.0)
+        return 1.0;
+      #if USE_SHADOW_PCF
+        return (
+          (v_shadow.z <= texture2D(shadowTex, v_shadow.xy + shadowOffsets1.xy).x ? 0.25 : 0.0) +
+          (v_shadow.z <= texture2D(shadowTex, v_shadow.xy + shadowOffsets1.zw).x ? 0.25 : 0.0) +
+          (v_shadow.z <= texture2D(shadowTex, v_shadow.xy + shadowOffsets2.xy).x ? 0.25 : 0.0) +
+          (v_shadow.z <= texture2D(shadowTex, v_shadow.xy + shadowOffsets2.zw).x ? 0.25 : 0.0)
+        );
+      #else
+        return (v_shadow.z <= texture2D(shadowTex, v_shadow.xy).x ? 1.0 : 0.0);
+      #endif
+    #endif
+  #else
+    return 1.0;
+  #endif
+}
+
+
+#define USE_PARALLAX      1
+#define USE_NORMAL_MAP    1
+#define USE_SPECULAR_MAP  1
+#define USE_SELF_LIGHT    1
+
+void main()
+{
+
+
+	vec3 color;
+	mat3 tbn;
+	vec2 coord = v_tex;
+	float sign = v_tangent.w;
+
+
+#if USE_PARALLAX
+	float h = texture2D(normTex, coord).a;
+
+	tbn = transpose(mat3(v_tangent.xyz, v_bitangent * sign, v_normal));
+
+	vec3 eyeDir = normalize( tbn * eyeVec );
+	float dist = length(eyeVec);
+
+	if (dist < 100 && h < 0.999)
+	{
+		float scale = 0.01;
+
+		if (dist > 65)
+		{
+			scale = 0.01 * (100 - dist) / 35.0;
+		}
+
+		float height = 1.0;
+		float iter;
+
+		float s;
+		vec2 move;
+		iter = (75 - (dist - 25)) / 3 + 5;
+
+		if (iter > 15) iter = 15;
+
+		vec3 tangEye = -eyeDir;
+
+		iter = mix(iter * 2, iter, tangEye.z);
+		
+		s = 1.0 / iter;
+		move = vec2(-eyeDir.x, eyeDir.y) * scale / (eyeDir.z * iter);
+
+		while (h < height) 
+		{
+			height -= s;
+			coord += move;
+			h = texture2D(normTex, coord).a;
+		}
+
+	}
+#endif
+	
+
+
+	tbn = transpose(mat3(v_tangent.xyz, v_bitangent * -sign, v_normal));
+	vec3 ntex = texture2D(normTex, coord).rgb * 2.0 - 1.0;
+	vec3 vNout = normalize(ntex * tbn);
+
+
+
+#if USE_NORMAL_MAP
+	float bump = max (dot (-sunDir, vNout), 0.0) ;
+#else
+	float bump = 1.0;
+#endif
+
+
+	vec3 specular;
+	vec4 specColour = vec4(1.0);
+#if USE_SPECULAR_MAP
+	specColour = texture2D(specTex, coord);
+	specular = bump * specColour.xyz * sunColor * pow(max(0.0, dot(normalize(vNout), v_half)), 12);
+#else
+	// if enabled, do normal specular
+	specular = vec3(0.0);
+#endif
+	
+
+	vec4 diffuse = texture2D(baseTex, coord);
+
+#if USE_TRANSPARENT
+	gl_FragColor.a = diffuse.a;
+#else
+	gl_FragColor.a = 1.0;
+#endif
+
+	vec3 texdiffuse = diffuse.rgb;
+
+	// Apply-coloring based on texture alpha
+#if USE_OBJECTCOLOR
+	texdiffuse *= mix(objectColor, vec3(1.0, 1.0, 1.0), diffuse.a);
+#else
+#if USE_PLAYERCOLOR
+	texdiffuse *= mix(playerColor, vec3(1.0, 1.0, 1.0), diffuse.a);
+#endif
+#endif
+
+
+
+
+	color = (texdiffuse + specular) * bump * sunColor * get_shadow() + texdiffuse * ambient;
+
+#if USE_SELF_LIGHT
+	color = mix(texdiffuse, color, specColour.a);
+#endif
+
+	
+
+
+#if !IGNORE_LOS
+	float los = texture2D(losTex, v_los).a;
+	color *= los;
+#endif
+
+  
+	gl_FragColor.rgb = color;
+}
